'''
Created on Dec 1, 2010
@author: Haitao
'''

def mazeReader(file):
    f=open(file,'r')
    dim=f.readline()
    size=[]
    
    for i in dim.split(' '):
        size.append(int(i))
    mazeRow=size[0]
    mazeColumn=size[1]
    
    maze=[]
    for line in f:
        maze.append(line.strip())
    
    for i in range(mazeRow):
        if ('B' in maze[i]):
            src=maze[i].index('B')+i*mazeColumn
        if ('X' in maze[i]):
            dest=maze[i].index('X')+i*mazeColumn
    return [maze,mazeRow,mazeColumn,src,dest]
    
def buildGraph(maze,mazeRow,mazeColumn):             
    graphSize=mazeRow*mazeColumn
    m=[[0]*(graphSize) for j in range(graphSize)]
    for i in range(mazeRow):
        for j in range(mazeColumn):
            v=j+mazeColumn*i
       
            upIndex=v-mazeColumn
            downIndex=v+mazeColumn
            leftIndex=v-1
            rightIndex=v+1

            upChar=downChar=leftChar=rightChar='O'

            if(i-1>0):upChar=maze[i-1][j]
            if(i+1<mazeRow):downChar=maze[i+1][j]
            if(j-1>0):leftChar=maze[i][j-1]            
            if(j+1<mazeColumn):rightChar=maze[i][j+1]
                
            if(upIndex>0 and upChar!='O' and downChar!='O'): m[v][upIndex]=1
            if(downIndex<graphSize and downChar!='O' and upChar!='O'): m[v][downIndex]=1
            if(leftIndex>0 and leftChar!='O' and rightChar!='O'): m[v][v-1]=1
            if(rightIndex<graphSize and rightChar!='O' and leftChar!='O'): m[v][v+1]=1
    return m            
        
def BFS(m,s,t):

    from Queue import Queue
    
    queue=Queue()
    queue.put(s)
    visited=[s]
    pMap={s:-1}
    
    while (not queue.empty()):
        startV=queue.get()
        for i in range(len(m)):
            if(m[startV][i]!=0 and (not (i in visited))):
                queue.put(i)
                visited.append(i)
                pMap[i]=startV
                if(i==t):
                    while(not queue.empty()):queue.get();
                    break;
    print 'Number of vertices visited in BFS: %d' %len(visited)
    return pMap

def parseResult(map,src,dest,mazeColumn):
    key=dest
    path=[]
    solution=[]
    while (map[key]!=-1):
        path.append(key);
        key=map[key];
    path.append(src)

    print 'Solution: '
    for i in range(len(path)-1):
        if((path[i+1]-path[i])==1):solution.append('\tMove Left')
        if((path[i+1]-path[i])==-1):solution.append('\tMove Right')
        if((path[i+1]-path[i])==-mazeColumn):solution.append('\tMove Down')
        if((path[i+1]-path[i])==mazeColumn):solution.append('\tMove Up')
    
    while (solution!=[]):
        print solution.pop()
        

file='M1.txt';
[maze,mazeRow,mazeColumn,src,dest]=mazeReader(file)
m=buildGraph(maze,mazeRow,mazeColumn)
pMap=BFS(m,src,dest)
parseResult(pMap,src,dest,mazeColumn)     
        
            
    
